<script setup lang="ts">
    import { InterventionFilters } from '@/logisticServiceOffer/entities/filters/InterventionFilters'
    import { isNull } from '@/shared/helpers/types'
    import { computed } from 'vue'

    const interventionFilters = defineModel<InterventionFilters>({
        required: true,
    })

    const computedCode = computed<string | undefined>({
        get() {
            return interventionFilters.value.filters.likeCode
        },
        set(newCode: string | undefined | null) {
            if (newCode === '' || isNull(newCode)) {
                interventionFilters.value.filters.likeCode = undefined
                return
            }
            interventionFilters.value.filters.likeCode = newCode
        },
    })
    const computedTitre = computed<string | undefined>({
        get() {
            return interventionFilters.value.filters.likeTitre
        },
        set(newTitre: string | undefined | null) {
            if (newTitre === '' || isNull(newTitre)) {
                interventionFilters.value.filters.likeTitre = undefined
                return
            }
            interventionFilters.value.filters.likeTitre = newTitre
        },
    })
    const computedCreatedBy = computed<string | undefined>({
        get() {
            return interventionFilters.value.filters.likeCreatedBy
        },
        set(newCreatedBy: string | undefined | null) {
            if (newCreatedBy === '' || isNull(newCreatedBy)) {
                interventionFilters.value.filters.likeCreatedBy = undefined
                return
            }
            interventionFilters.value.filters.likeCreatedBy = newCreatedBy
        },
    })
</script>

<template>
    <span class="d-flex align-baseline py-4 pl-2">
        <v-icon size="large">mdi-filter-outline</v-icon>
        <h2 class="text-h8 ml-2">Filtres</h2>
    </span>

    <v-list lines="one">
        <v-list-item>
            <v-text-field
                v-model="computedCode"
                label="Code"
                data-cy="filtre-code"
                class="mt-1"
                :hide-details="true"
                placeholder="ex: *064898"
                clearable
            ></v-text-field>
        </v-list-item>
        <v-list-item>
            <v-text-field
                v-model="computedTitre"
                label="Titre"
                :hide-details="true"
                data-cy="filtre-titre"
                class="mt-1"
                placeholder="ex: *EPI*"
                clearable
            ></v-text-field>
        </v-list-item>
        <v-list-item>
            <v-text-field
                v-model="computedCreatedBy"
                label="Demandeur"
                :hide-details="true"
                data-cy="filtre-createdBy"
                class="mt-1"
                placeholder="ex: *Michel*"
                clearable
            ></v-text-field>
        </v-list-item>
    </v-list>
</template>
